Anti cheating plugin for Minecraft (Bukkit/Spigot).
Java Python
Latest commit e3d5b70 Feb 22, 2017 @asofold asofold Order.
(See if hooks work now.)
Permalink
Failed to load latest commit information.
NCPBuildBase Ready for UEFA EC: GPLv3 headers. Jun 2, 2016
NCPCommons [BLEEDING] Reflection module: access entity bounds/height etc. Nov 22, 2016
NCPCompatBukkit Don't use the pre-1.11 method past 1.11. Dec 29, 2016
NCPCompatCB2512 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2545 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2602 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2645 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2691 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2763 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2794 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2808 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2882 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB2922 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB3026 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB3043 [BREAKING] Move more classes around. Jun 21, 2016
NCPCompatCB3100 Fix NoFall issues on Spigot/MC 1.7.10. Jan 22, 2017
NCPCompatCBDev [BLEEDING] Since builds fail with 1.11, use 1.11.2 here. Dec 29, 2016
NCPCompatProtocolLib Track the current world name in ChatData for now. Dec 29, 2016
NCPCompatSpigotCB1_10_R1 [BLEEDING] Use early 1.10 and 1.11 for native dependencies. Dec 29, 2016
NCPCompatSpigotCB1_8_R1 isIllegalBounds: Check for bad coordinates as well. Down to 1.7.10. Dec 27, 2016
NCPCompatSpigotCB1_8_R2 isIllegalBounds: Check for bad coordinates as well. Down to 1.7.10. Dec 27, 2016
NCPCompatSpigotCB1_8_R3 isIllegalBounds: Check for bad coordinates as well. Down to 1.7.10. Dec 27, 2016
NCPCompatSpigotCB1_9_R1 isIllegalBounds: Check for bad coordinates as well. Down to 1.7.10. Dec 27, 2016
NCPCompatSpigotCB1_9_R2 isIllegalBounds: Check for bad coordinates as well. Down to 1.7.10. Dec 27, 2016
NCPCore Order. Feb 22, 2017
NCPPlugin Don't give silent permissions as child permissions by default. Jan 17, 2017
NoCheatPlus Use https for dbo. Dec 4, 2016
CONTRIBUTING.md Tickets are now on GitHub: https://github.com/NoCheatPlus/Issues/issues Dec 12, 2015
LICENSE.txt Put license on top level. Jan 12, 2013
README.md Dummy commit to check stuff. Jan 17, 2017
copy_NCPCompatCBDev.py Oops. Dec 27, 2016
pom.xml Add a dedicated compatibility module for 1.10.x (1.10 R1). Dec 27, 2016

README.md

NoCheatPlus

NoCheatPlus is a fork of the famous anti-cheat plugin [NoCheat] (https://dev.bukkit.org/server-mods/nocheat/) created by [Evenprime] (https://github.com/Evenprime). NoCheatPlus attempts to enforce "vanilla Minecraft" mechanics, as well as preventing players from abusing weaknesses in Minecraft or its protocol, making your server more safe. Organized in different sections, various checks are performed to test players doing, covering a wide range including flying and speeding, fighting hacks, fast block breaking and nukers, inventory hacks, chat spam and other types of malicious behaviour. For a more complete list have a look at the always outdated [Features Page] (https://github.com/NoCheatPlus/Docs/wiki/Features).

Installation

Tips

Compiling NoCheatPlus

  • NoCheatPlus used to be compiled with java 6 compliance (note OpenJDK, possibly we'll switch to 8 directly, once appropriate, e.g. with ProtocolLib dropping support for 7.).
  • We use [Maven] (http://maven.apache.org/download.cgi) 3 to handle the dependencies.
  • You can compile with this Maven goal: mvn clean package, if you don't want any dedicated CraftBukkit modules, or if you are lacking the jar files - for best performance and compatibility, choose the appropriate build profile(s) from below. If you do have all the legacy dependencies, you can set the parameter cbdedicated to true and activate the profile all adding -P all to the maven goals. For more options, see the table below. If your specific needs are not met by the provided options, you can still build only using the compat module(s) that you need, e.g. by adjusting the build/dependency profiles or adding your own profile, which means changing/adding a profile both in the root pom.xml for modules to have and in NCPPlugin/pom.xml for the dependency inclusion. The preset profiles should be enough of a hint for that. If you add custom modules with a different package naming than fr.neatmonster, you might have to add the source inclusion to the NoCheatPlus/pom.xml as well.
  • Jar files for the dedicated compat modules, which your local maven repository might be missing, can be installed manually. Example for Eclipse with embedded maven: Add a new maven build run configuration, name it appropriately, e.g. Install CB 1.7.5. Set goals to: install:install-file -Dfile=<PATH TO JAR> -DgroupId=org.bukkit -DartifactId=craftbukkit -Dversion=1.7.5-R0.1-SNAPSHOT -Dpackaging=jar On Windows the might look like: X:\...\craftbukkit\3042\craftbukkit-1.7.5-R0.1-20140408.020329-16.jar To let it run you might have to set the base directory, e.g. to ${workspace_loc}, it does not seem to have significance. Do set the correct version alongside the file name. On newer version of maven, you might do with much simplified goals, because the pom files inside the jars are parsed.

All profiles for reference:

As of now, you do need to activate the ncp_base profile in addition to whichever other profile you may be using.

For some building environments you might need to both set the profiles and set the build parameters - to be on the safe side, just set both.

Profile Parameter set to true Description
-P ncp_base ncp_base Default profile without any of the native access modules, might pose compatibility issues with latest Minecraft versions. The reflection based module is included here.
-P all-P ncp_base cbdedicated and ncp_base All compatibility modules.
-P spigot1_7_r4 -P ncp_base spigot1_7_r4 and ncp_base Just Spigot 1.7 R4 (MC 1.7.10).
-P spigot1_8_r3 -P ncp_base spigot1_8_r3 and ncp_base Just Spigot 1.8 R3 (MC 1.8.4-1.8.8).
-P spigot1_9_r1 -P ncp_base spigot1_9_r1 and ncp_base Just Spigot 1.9 R1 (MC 1.9-1.9.3).
-P spigot1_9_r2 -P ncp_base spigot1_9_r2 and ncp_base Just Spigot 1.9 R2 (MC 1.9.4).
-P spigot1_10_r1 -P ncp_base spigot1_10_r1 and ncp_base Just Spigot 1.10 R1 (MC 1.10-1.10.2).
-P spigot1_11_r1 -P ncp_base spigot1_11_r1 and ncp_base Just Spigot 1.11 R1 (MC 1.11-1.11.2).
-P cbdev -P ncp_base cbdev and ncp_base The latest version in development.

(On the long run, only the latest module for a major Minecraft release may be be kept, such as 1_8_r3 for all of 1.8.x.)

Links

Project

Download

Support and Documentation

Developers

TODO: BLEEDING REPO

Related